/***************************************************************************
 *                                                                         *
 *  MAXIMUS-CBCS Source Code, Version 1.02                                 *
 *  Copyright 1989, 1990 by Scott J. Dudley.  All rights reserved.         *
 *                                                                         *
 *  Set file date/time                                                     *
 *                                                                         *
 *  For complete details of the licensing restrictions, please refer to    *
 *  the licence agreement, which is published in its entirety in MAX.C     *
 *  and LICENCE.MAX.                                                       *
 *                                                                         *
 *  USE OF THIS FILE IS SUBJECT TO THE RESTRICTIONS CONTAINED IN THE       *
 *  MAXIMUS-CBCS LICENSING AGREEMENT.  IF YOU DO NOT FIND THE TEXT OF THIS *
 *  AGREEMENT IN ANY OF THE  AFOREMENTIONED FILES, OR IF YOU DO NOT HAVE   *
 *  THESE FILES, YOU SHOULD IMMEDIATELY CONTACT THE AUTHOR AT ONE OF THE   *
 *  ADDRESSES LISTED BELOW.  IN NO EVENT SHOULD YOU PROCEED TO USE THIS    *
 *  FILE WITHOUT HAVING ACCEPTED THE TERMS OF THE MAXIMUS-CBCS LICENSING   *
 *  AGREEMENT, OR SUCH OTHER AGREEMENT AS YOU ARE ABLE TO REACH WITH THE   *
 *  AUTHOR.                                                                *
 *                                                                         *
 *  You can contact the author at one of the address listed below:         *
 *                                                                         *
 *  Scott Dudley           FidoNet  1:249/106                              *
 *  777 Downing St.        IMEXnet  89:483/202                             *
 *  Kingston, Ont.         Internet f106.n249.z1.fidonet.org               *
 *  Canada - K7M 5N3       BBS      (613) 389-8315 - HST/14.4K, 24hrs      *
 *                                                                         *
 *  Thanks to Peter Fitzsimmons for these routines.                        *
 *                                                                         *
 ***************************************************************************/

#ifdef OS_2
#define INCL_NOPM
#define INCL_DOS
#include <os2.h>
#endif
#include "prog.h"

#ifdef OS_2

struct FileInfoBuf {
                     unsigned short cre_date, cre_time;  /* not supported yet */
                     unsigned short acc_date, acc_time;  /* not supported yet */
                     unsigned short write_date;  /* date/time of last write to file */
                     unsigned short write_time;
                  };

/* set file date/time. OS/2 version */
int set_fdt(int handle, union stamp_combo *filestamp)
{
   struct FileInfoBuf fib;
   int stat;

   fib.cre_date = fib.cre_time = 0;
   fib.acc_date = fib.acc_time = 0;

   fib.write_date = filestamp->dos_st.date;
   fib.write_time = filestamp->dos_st.time;

   stat = DosSetFileInfo( handle, 1, (void *)&fib, sizeof(fib));
   return(stat);
}

#else
#include "dos.h"

/* set date and time of file, using int 21h (MS-DOS)  */
int set_fdt(int handle, union stamp_combo *filestamp)
{
   union REGS regs;

   regs.h.ah=0x57;                         /* get/set date/time call */
   regs.h.al=0x01;                         /* set date/time */
   regs.x.bx= handle;
   regs.x.dx=filestamp->dos_st.date;
   regs.x.cx=filestamp->dos_st.time;
   int86(0x21, &regs,&regs);
   if(regs.x.cflag)
      return(regs.x.ax);
   else
      return(0);
}
#endif

